# Spec file for Qpid QMF packages
# svn revision: $Rev$

%{!?python_sitelib: %global python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}
%{!?python_sitearch: %global python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}

%{!?ruby_sitelib: %global ruby_sitelib %(/usr/bin/ruby -rrbconfig  -e 'puts Config::CONFIG["sitelibdir"] ')}
%{!?ruby_sitearch: %global ruby_sitearch %(/usr/bin/ruby -rrbconfig -e 'puts Config::CONFIG["sitearchdir"] ')}

# NOTE: no more than one of these flags should be set at the same time!
# RHEL-6 builds (the default) should have all these flags set to 0.
%global fedora              0
%global rhel_5              1

# LIBRARY VERSIONS
# Update these lib numbers in accordance with library numbering policy
# and best practices.
# http://www.gnu.org/software/libtool/manual/libtool.html#Versioning
#
# Fromat: current[:revision[:age]]
#
# current:  The most recent interface number that this library
#           implements.
# revision: The implementation number of the current interface.
# age:      The difference between the newest and oldest interfaces that
#           this library implements.  In other words, the library
#           implements all the interface numbers in the range from
#           number current - age to current.
#
#  1. Start with version information of ‘0:0:0’ for each libtool
#     library.
#  2. Update the version information only immediately before a public
#     release of your software.  More frequent updates are
#     unnecessary, and only guarantee that the current interface
#     number gets larger faster.
#  3. If the library source code has changed at all since the last
#     update, then increment revision (‘c:r:a’ becomes ‘c:r+1:a’).
#  4. If any interfaces have been added, removed, or changed since the
#     last update, increment current, and set revision to 0.
#  5. If any interfaces have been added since the last public release,
#     then increment age.
#  6. If any interfaces have been removed or changed since the last
#     public release, then set age to 0.

%global QPIDCOMMON_VERSION_INFO             8:0:0
%global QPIDTYPES_VERSION_INFO              3:2:2 
%global QPIDBROKER_VERSION_INFO             8:0:0
%global QPIDCLIENT_VERSION_INFO             8:0:0
%global QPIDMESSAGING_VERSION_INFO          5:2:2
%global RDMAWRAP_VERSION_INFO               8:0:0
%global SSLCOMMON_VERSION_INFO              8:0:0

%global QMF_VERSION_INFO                    6:0:0
%global QMF2_VERSION_INFO                   1:2:0
%global QMFENGINE_VERSION_INFO              6:0:0
%global QMFCONSOLE_VERSION_INFO             7:0:0

# Single var with all lib version params (except store) for make
%global LIB_VERSION_MAKE_PARAMS QPIDCOMMON_VERSION_INFO=%{QPIDCOMMON_VERSION_INFO} QPIDTYPES_VERSION_INFO=%{QPIDTYPES_VERSION_INFO} QPIDBROKER_VERSION_INFO=%{QPIDBROKER_VERSION_INFO} QPIDCLIENT_VERSION_INFO=%{QPIDCLIENT_VERSION_INFO} QPIDMESSAGING_VERSION_INFO=%{QPIDMESSAGING_VERSION_INFO} QMF_VERSION_INFO=%{QMF_VERSION_INFO} QMF2_VERSION_INFO=%{QMF2_VERSION_INFO} QMFENGINE_VERSION_INFO=%{QMFENGINE_VERSION_INFO} QMFCONSOLE_VERSION_INFO=%{QMFCONSOLE_VERSION_INFO} RDMAWRAP_VERSION_INFO=%{RDMAWRAP_VERSION_INFO} SSLCOMMON_VERSION_INFO=%{SSLCOMMON_VERSION_INFO}

Name:          qpid-qmf
Version:       0.18
Release:       29%{?dist}
Summary:       The Qpid Management Framework
Group:         System Environment/Libraries
License:       ASL 2.0
URL:           http://qpid.apache.org
Source0:       qpid-%{version}.tar.gz
Patch0:        mrg.patch
Patch1:        configure.patch
Patch2:        mrg-2.3.3.patch
Patch3:        mrg-2.3.6.patch
Patch4:        mrg-2.4.4.patch
Patch5:        mrg-2.5.1.patch
Patch6:        mrg-2.5.5.patch
Patch7:        mrg-2.5.9.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%if %{rhel_5}
ExclusiveArch: i386 x86_64
%endif

BuildRequires: boost-devel
BuildRequires: libtool
BuildRequires: pkgconfig
BuildRequires: ruby
BuildRequires: ruby-devel
BuildRequires: python-devel
BuildRequires: swig
BuildRequires: nss-devel
BuildRequires: nspr-devel

%if %{rhel_5}
BuildRequires: e2fsprogs-devel
%else
BuildRequires: boost-program-options
BuildRequires: boost-filesystem
BuildRequires: libuuid-devel
%endif


# === Package: qpid-qmf ===

Requires:      qpid-cpp-client = %{version}
Provides:      qmf = %{version}-%{release}
Obsoletes:     qmf < %{version}-%{release}

%description
An extensible management framework layered on Qpid messaging

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root,-)
%{_libdir}/libqmf.so.*
%{_libdir}/libqmf2.so.*
%{_libdir}/libqmfengine.so.*
%{_libdir}/libqmfconsole.so.*
%exclude %{_libdir}/*.la


# === Package: qpid-qmf-devel ===
%package devel
Summary:       Header files and tools for developing QMF extensions
Group:         Development/System
Requires:      qpid-qmf = %{version}-%{release}
Requires:      qpid-cpp-client-devel = %{version}
Provides:      qmf-devel = %{version}-%{release}
Obsoletes:     qmf-devel < %{version}-%{release}

%description devel
Header files and code-generation tools needed for developers of QMF-managed
components.

%post devel -p /sbin/ldconfig

%postun devel -p /sbin/ldconfig

%files devel
%defattr(-,root,root,-)
%{_libdir}/libqmf.so
%{_libdir}/libqmf2.so
%{_libdir}/libqmfengine.so
%{_libdir}/libqmfconsole.so
%{_bindir}/qmf-gen
%{python_sitelib}/qmfgen
%{_includedir}/qmf
%{_includedir}/qpid/agent
%{_includedir}/qpid/console


# === Package: python-qpid-qmf ===
%package -n python-qpid-qmf
Summary:       Python QMF library for Apache Qpid
Group:         Development/Python
Requires:      qpid-qmf = %{version}-%{release}
Requires:      qpid-cpp-client = %{version}
Requires:      python-qpid = %{version}
Provides:      python-qmf = %{version}-%{release}
Obsoletes:     python-qmf < %{version}-%{release}

%description -n python-qpid-qmf
Python QMF library for Apache Qpid

%files -n python-qpid-qmf
%defattr(-,root,root,-)
%{python_sitearch}/qmf
%{python_sitearch}/cqpid.py*
%{python_sitearch}/_cqpid.so
%{python_sitearch}/qmf.py*
%{python_sitearch}/qmfengine.py*
%{python_sitearch}/_qmfengine.so
%{python_sitearch}/qmf2.py*
%{python_sitearch}/cqmf2.py*
%{python_sitearch}/_cqmf2.so
%exclude %{python_sitearch}/mllib
%exclude %{python_sitearch}/qpid
#%exclude %{python_sitelib}/*.egg-info


# === Package: ruby-qpid-qmf ===

%ifnarch s390 s390x ppc ppc64

%package -n ruby-qpid-qmf
Summary:       The QPID Management Framework bindings for ruby
Group:         System Environment/Libraries
Requires:      qpid-cpp-client = %{version}
Requires:      qpid-qmf = %{version}-%{release}
Provides:      ruby-qmf = %{version}-%{release}
Obsoletes:     ruby-qmf < %{version}-%{release}

%description -n ruby-qpid-qmf
An extensible managememt framework layered on QPID messaging, bindings
for ruby.

%post -n ruby-qpid-qmf -p /sbin/ldconfig

%postun -n ruby-qpid-qmf -p /sbin/ldconfig

%files -n ruby-qpid-qmf
%defattr(-,root,root,-)
%{ruby_sitelib}/qmf.rb
%{ruby_sitelib}/qmf2.rb
%{ruby_sitearch}/qmfengine.so
%{ruby_sitearch}/cqpid.so
%{ruby_sitearch}/cqmf2.so
%exclude %{ruby_sitearch}/*.la

%endif

# ===

%prep
%setup -q -n qpid-%{version}
%patch0 -p2
%patch1 -p2
%patch2 -p2
%patch3 -p2
%patch4 -p2
%patch5 -p2
%patch6 -p2
%patch7 -p2

%build
(
    cd cpp
    ./bootstrap
    export CXXFLAGS="%{optflags} -DNDEBUG -O3"
    %configure --with-swig --without-sasl --without-ssl \
        --without-help2man --without-cpg --without-libcman --without-xml \
        --without-rdma --without-doxygen
    %{__make} %{LIB_VERSION_MAKE_PARAMS}
)

(cd python; %{__python} setup.py build)
(cd extras/qmf; %{__python} setup.py build)

%install
rm -rf %{buildroot}

(cd cpp; make install DESTDIR=%{buildroot})
(cd python; %{__python} setup.py install --skip-build --root %{buildroot} --install-purelib %{python_sitearch})
(cd extras/qmf; %{__python} setup.py install --skip-build --root %{buildroot} --install-purelib %{python_sitearch})


install -d %{buildroot}%{python_sitearch}
install -pm 644 %{_builddir}/qpid-%{version}/cpp/bindings/qpid/python/cqpid.py %{buildroot}%{python_sitearch}
#install -pm 644 %{_builddir}/qpid-%{version}/cpp/bindings/qpid/python/.libs/_cqpid.so %{buildroot}%{python_sitearch}
install -pm 644 %{_builddir}/qpid-%{version}/cpp/bindings/qmf/python/*.py %{buildroot}%{python_sitearch}
#install -pm 644 %{_builddir}/qpid-%{version}/cpp/bindings/qmf/python/.libs/_qmfengine.so %{buildroot}%{python_sitearch}
install -pm 644 %{_builddir}/qpid-%{version}/cpp/bindings/qmf2/python/*.py %{buildroot}%{python_sitearch}
#install -pm 644 %{_builddir}/qpid-%{version}/cpp/bindings/qmf2/python/.libs/_cqmf2.so %{buildroot}%{python_sitearch}


shopt -s extglob

rm -fr %{buildroot}%{_libdir}/!(libqmf*|ruby|python*)
rm -fr %{buildroot}%{_localstatedir}
rm -fr %{buildroot}%{_mandir}
rm -fr %{buildroot}%{_bindir}/!(qmf*)
rm -fr %{buildroot}%{_includedir}/qpid/!(agent|console)
rm -fr %{buildroot}%{_includedir}/qmf/org
rm -fr %{buildroot}%{_libexecdir}
rm -fr %{buildroot}%{_sbindir}
rm -fr %{buildroot}%{_sysconfdir}
rm -fr %{buildroot}%{_datadir}
rm -fr %{buildroot}%{python_sitelib}/qpid*.egg-info
rm -fr %{buildroot}%{python_sitearch}/qpid*.egg-info
rm -fr %{buildroot}%{python_sitelib}/_*.la
rm -fr %{buildroot}%{python_sitearch}/_*.la

%ifarch x86_64 s390x ppc64                   
rm -fr %{buildroot}%{python_sitelib}/cqmf.py*                 
rm -fr %{buildroot}%{python_sitelib}/cqpid.py*
rm -fr %{buildroot}%{python_sitelib}/qmf.py*
rm -fr %{buildroot}%{python_sitelib}/qmfengine.py*
rm -fr %{buildroot}%{python_sitelib}/cqmf2.py*
rm -fr %{buildroot}%{python_sitelib}/qmf2.py*
%endif                                          

%ifarch s390 s390x ppc ppc64
rm -fr %{buildroot}%{ruby_sitelib}/qmf.rb
rm -fr %{buildroot}%{ruby_sitelib}/qmf2.rb
rm -fr %{buildroot}%{ruby_sitearch}/qmfengine.so
rm -fr %{buildroot}%{ruby_sitearch}/cqpid.so
rm -fr %{buildroot}%{ruby_sitearch}/cqmf2.so
rm -fr %{buildroot}%{ruby_sitearch}/*.la
%endif

%clean
rm -rf %{buildroot}

%changelog
* Wed Nov 12 2014 Mike Cressman <mcressma@redhat.com> - 0.18-29
- BZ 1153763 - disable SSLv3 in cpp client and broker
- BZ 1153775 - disable SSLv3 in windows cpp client

* Thu Oct 9 2014 Mike Cressman <mcressma@redhat.com> - 0.18-28
- remove BZ 1142833 (undo moving purging to a worker thread)
- BZ 1147968 - Session.nextReceiver() with IMMEDIATE duration does not raise exception when connection is closed

* Fri Sep 19 2014 Mike Cressman <mcressma@redhat.com> - 0.18-27
- BZ 1142866 Purging TTL expired messages takes longer than before
- BZ 1142833 Purging TTL expired messages blocks all other timers, causing connection drops

* Wed Sep 10 2014 Mike Cressman <mcressma@redhat.com> - 0.18-26
- BZ 1136294 - memory leak when purging priority ring queue
- BZ 1132395 - memory leak when using federation with unreliable link
- BZ 1128654 - nextReceiver with IMMEDIATE duration always returns null
- BZ 1121615 - message to ring queue with prio>9 causes segfault
- BZ 860691 - fix performance for large priority ring queue

* Mon Jun 9 2014 Mike Cressman <mcressma@redhat.com> - 0.18-24
- BZ 1103094 - fix deadlock and memory leak with auto-delete queue timeout

* Thu May 22 2014 Mike Cressman <mcressma@redhat.com> - 0.18-23
- BZ 1079260 - QMF statistics for LVQs get corrupted
- BZ 1094781 - federated link ends up in connecting state forever after connecting while broker is shutting down

* Fri Jan 17 2014 Mike Cressman <mcressman@redhat.com> - 0.18-20
- BZ  966004 - use correct exception object for older ssl implementations
- BZ 1030406 - segfault in Queue::isExpired() when debug logging for queue is enabled
- BZ 1030608 - qpid segfaults in qpid::ha::BrokerReplicator::disconnected
- BZ 1030637 - cluster restart with cluster-size=3, auth=yes
- BZ 1036650 - ensure that replaced LVQ messages are deleted from store
- BZ 1041575 - don't delete subscription queue when closing link if it was explicitly declared non-exclusive
- BZ 1042224 - durable LVQ raises journal error when only transient messages are sent
- BZ 1044002 - setting heartbeat has no effect on connection establishment timeout

* Wed Jun 19 2013 Mike Cressman <mcressman@redhat.com> - 0.18-18
- BZ 964189 - improved the counting for replication shutoff
- BZ 971295 - change name of replication shutoff switch
- BZ 948489 - get replication shutoff working correctly w/cluster

* Mon Jun 3 2013 Mike Cressman <mcressman@redhat.com> - 0.18-17
- BZ 951296 - removed new --credit switch, instead set federation
  credit unlimited to avoid qmf schema change in MRG 2.3

* Wed May 15 2013 Mike Cressman <mcressman@redhat.com> - 0.18-16
- Errata build 1
- BZs: 847038,861162,868951,923452,948489,951719,951296,953777
       956240,957869,958895,961444
- HA BZs: 955718,955752

* Wed Feb 13 2013 Irina Boverman <iboverma@redhat.com> - 0.18-15
- Resolves: rhbz895535

* Thu Jan 24 2013 Irina Boverman <iboverma@redhat.com> - 0.18-14
- Make it consistent with qpid-cpp 0.18-14

* Wed Dec 12 2012 Irina Boverman <iboverma@redhat.com> - 0.18-13
- Make it consistent with qpid-cpp 0.18-13

* Tue Dec  4 2012 Irina Boverman <iboverma@redhat.com> - 0.18-12
- Resolves: rhbz877553, Make it consistent with qpid-cpp 0.18-12

* Wed Nov 21 2012 Mike Cressman <mcressman@redhat.com> - 0.18-9
- Rebuild to really make it consistent with qpid-cpp 0.18-10

* Tue Nov 20 2012 Irina Boverman <iboverma@redhat.com> - 0.18-8
- Make it consistent with qpid-cpp 0.18-10

* Tue Nov 13 2012 Irina Boverman <iboverma@redhat.com> - 0.18-7
- Resolves: rhbz876136, make it consistent with qpid-cpp 0.18-9

* Wed Nov  7 2012 Irina Boverman <iboverma@redhat.com> - 0.18-6
- Make it consistent with qpid-cpp 0.18-7

* Fri Nov  2 2012 Irina Boverman <iboverma@redhat.com> - 0.18-5
- Changed QMF version numbers

* Thu Nov  1 2012 Irina Boverman <iboverma@redhat.com> - 0.18-4
- Make it consistent with latest qpid-cpp

* Wed Oct 31 2012 Irina Boverman <iboverma@redhat.com> - 0.18-3
- Make is consistent with qpid-cpp 0.18-3
- Added configure.patch to resolve problems building on RHEL 5

* Sun Oct 14 2012 Irina Boverman <iboverma@redhat.com> - 0.18-2
- BZs: 845367, Rebase to 0.18+, 0.18-1
- Make it consistent with qpid-cpp 0.18-2

* Thu Aug 16 2012 Justin Ross <jross@redhat.com> - 0.14-14
- BZs: 693845, 773700, 806869, 847331
* Mon Apr 16 2012 Justin Ross <jross@redhat.com> - 0.14-9
- rhbz#811469 - Make swig python wrappers compatible with older
  versions of Python and Swig
* Tue Apr 10 2012 Nuno Santos <nsantos@redhat.com> - 0.14-7
- Updated mrg.patch
* Mon Apr  2 2012 Justin Ross <jross@redhat.com> - 0.14-6
- Rebase to 0.14
- rhbz#804001 - Incremented qpid-cpp lib versions
- rhbz#743657 - The pure-python QMF console unnecessarily retains
  references to query results
- rhbz#699499 - [RFE] qmfv2 must provide mainloop integration
- rhbz#681680 - QMF agents wake up several times a second
- rhbz#663461 - Enable new architectures
* Fri Mar 23 2012 Nuno Santos <nsantos@redhat.com> - 0.14-4
- rhbz#804001 - incremented qpid-cpp lib versions
* Tue Feb 14 2012 Nuno Santos <nsantos@redhat.com> - 0.14-3
- Updated mrg patch
* Thu Dec  8 2011 Nuno Santos <nsantos@redhat.com> - 0.14-2
- Fixed install paths
* Tue Nov 29 2011 Justin Ross <jross@redhat.com> - 0.14-1
- Remove python-qpid-qmf and ruby-qpid-qmf from ppc and s390 architectures
* Mon Oct 31 2011 Justin Ross <jross@redhat.com> - 0.10-11
- BZs 743657, 748738 - Prevent memory leak in python console
* Mon May 27 2011 Ted Ross <tross@redhat.com> - 0.10-10
- BZ 709343 - Packaging problem in qpid-qmf-devel (qmf-gen templates)
* Mon May 24 2011 Ted Ross <tross@redhat.com> - 0.10-9
- BZ 707023 - Fix rpmdiff errors
* Mon May  2 2011 Ted Ross <tross@redhat.com> - 0.10-7
- BZ 689907 - Fix rpmdiff errors
* Wed Apr 20 2011 Justin Ross <jross@redhat.com> - 0.10-6
- BZ 694416 - missing dependency of python-qpid-qmf
* Wed Mar 30 2011 Nuno Santos <nsantos@redhat.com> - 0.10-3
- BZ691812
* Tue Mar 22 2011 Nuno Santos <nsantos@redhat.com> - 0.10-1
- Initial version of consolidated, renamed qpid-qmf packages
